"use strict";

exports.__esModule = true;

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require("react-bootstrap");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames4 = require("classnames");

var _classnames5 = _interopRequireDefault(_classnames4);

require("./index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var stepRefs = {};
var ReactWizard = function ReactWizard(props) {

    props.steps.forEach(function (step) {
        if (!stepRefs[step.stepName]) {
            stepRefs[step.stepName] = (0, _react.useRef)();
        }
    });

    return _react2.default.createElement(Wizard, _extends({}, props, { stepRefs: stepRefs }));
};

var StepProgress = function StepProgress(_ref) {
    var steps = _ref.steps,
        currentStep = _ref.currentStep,
        highestStep = _ref.highestStep,
        color = _ref.color,
        stepButtonClasses = _ref.stepButtonClasses;

    var progressValue = 0;
    switch (currentStep) {
        case 0:
            {
                progressValue = 0;
                break;
            }
        case steps.length - 1:
            {
                progressValue = 100;
                break;
            }

        default:
            {
                progressValue = currentStep / (steps.length - 1) * 100;
            }
    }
    return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
            _reactBootstrap.Nav,
            { variant: "pills" },
            _react2.default.createElement(
                "div",
                { className: "progress-wrapper text-center" },
                _react2.default.createElement(
                    _reactBootstrap.Row,
                    { className: "w-100" },
                    _react2.default.createElement(
                        _reactBootstrap.Col,
                        { xs: 12 },
                        _react2.default.createElement(_reactBootstrap.ProgressBar, { now: progressValue, variant: color })
                    )
                )
            ),
            _react2.default.createElement(
                _reactBootstrap.Row,
                { className: "w-100", noGutters: true },
                steps.map(function (prop, key) {
                    return _react2.default.createElement(
                        _reactBootstrap.Col,
                        { key: key },
                        _react2.default.createElement(
                            _reactBootstrap.Nav.Item,
                            null,
                            _react2.default.createElement(
                                _reactBootstrap.Nav.Link,
                                { eventKey: key,
                                    className: (stepButtonClasses ? stepButtonClasses : '') + (key === currentStep || key <= highestStep ? ' active checked bg-' + color : '')

                                },
                                prop.stepIcon !== undefined && prop.stepIcon !== "" ? _react2.default.createElement("i", { className: prop.stepIcon }) : null,
                                _react2.default.createElement(
                                    "span",
                                    null,
                                    "\xA0",
                                    prop.stepName
                                )
                            )
                        )
                    );
                })
            )
        )
    );
};

var Wizard = function (_React$Component) {
    _inherits(Wizard, _React$Component);

    function Wizard(props) {
        _classCallCheck(this, Wizard);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.state = {
            currentStep: 0,
            highestStep: 0,
            color: _this.props.color !== undefined ? _this.props.color : "primary",
            nextButton: _this.props.steps.length > 1 ? true : false,
            previousButton: false,
            finishButton: _this.props.steps.length === 1 ? true : false

            // movingTabStyle: {
            //     transition: "transform 0s"
            // }
        };

        _this.navigationStepChange = _this.navigationStepChange.bind(_this);
        _this.refreshAnimation = _this.refreshAnimation.bind(_this);
        _this.previousButtonClick = _this.previousButtonClick.bind(_this);
        _this.previousButtonClick = _this.previousButtonClick.bind(_this);
        _this.finishButtonClick = _this.finishButtonClick.bind(_this);
        return _this;
    }

    Wizard.prototype.componentDidMount = function componentDidMount() {
        this.refreshAnimation(0);
        window.addEventListener("resize", this.updateWidth.bind(this));
    };

    Wizard.prototype.componentWillUnmount = function componentWillUnmount() {

        var ctx = this;
        //Reset components if wizard close
        this.props.steps.forEach(function (step) {
            if (ctx.props.stepRefs[step.stepName] && ctx.props.stepRefs[step.stepName].current.reset) {
                ctx.props.stepRefs[step.stepName].current.reset();
            }
        });

        this.isCancelled = true;
        window.removeEventListener("resize", this.updateWidth);
        var id = window.setTimeout(null, 0);
        while (id--) {
            window.clearTimeout(id);
        }
    };

    Wizard.prototype.updateWidth = function updateWidth() {
        var _this2 = this;

        !this.isCancelled && setTimeout(function () {
            return _this2.refreshAnimation(_this2.state.currentStep);
        }, 200);
    };

    Wizard.prototype.navigationStepChange = function navigationStepChange(key) {
        if (this.props.navSteps) {
            var validationState = true;
            if (this.props.validate && key > this.state.currentStep) {
                for (var i = this.state.currentStep; i < key; i++) {
                    if (this.props.stepRefs[this.props.steps[i].stepName].current.isValidated !== undefined && this.props.stepRefs[this.props.steps[i].stepName].current.isValidated() === false) {
                        validationState = false;
                        break;
                    }
                }
            }
            if (validationState) {
                this.setState({
                    currentStep: key,
                    highestStep: key > this.state.highestStep ? key : this.state.highestStep,
                    nextButton: this.props.steps.length > key + 1 ? true : false,
                    previousButton: key > 0 ? true : false,
                    finishButton: this.props.steps.length === key + 1 ? true : false
                });
                this.refreshAnimation(key);
            }
        }
    };

    Wizard.prototype.nextButtonClick = function () {
        var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
            var key;
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            if (!(this.props.validate && (this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.isValidated !== undefined && this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.isValidated() || this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.isValidated === undefined) || this.props.validate === undefined || !this.props.validate)) {
                                _context.next = 12;
                                break;
                            }

                            _context.prev = 1;

                            if (!this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.onClickNext) {
                                _context.next = 5;
                                break;
                            }

                            _context.next = 5;
                            return this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.onClickNext();

                        case 5:
                            key = this.state.currentStep + 1;

                            this.setState({

                                currentStep: key,
                                highestStep: key > this.state.highestStep ? key : this.state.highestStep,
                                nextButton: this.props.steps.length > key + 1 ? true : false,
                                previousButton: key > 0 ? true : false,
                                finishButton: this.props.steps.length === key + 1 ? true : false
                            });
                            this.refreshAnimation(key);
                            _context.next = 12;
                            break;

                        case 10:
                            _context.prev = 10;
                            _context.t0 = _context["catch"](1);

                        case 12:
                        case "end":
                            return _context.stop();
                    }
                }
            }, _callee, this, [[1, 10]]);
        }));

        function nextButtonClick() {
            return _ref2.apply(this, arguments);
        }

        return nextButtonClick;
    }();

    Wizard.prototype.previousButtonClick = function previousButtonClick() {
        var key = this.state.currentStep - 1;
        if (key >= 0) {
            this.setState({

                currentStep: key,
                highestStep: key > this.state.highestStep ? key : this.state.highestStep,
                nextButton: this.props.steps.length > key + 1 ? true : false,
                previousButton: key > 0 ? true : false,
                finishButton: this.props.steps.length === key + 1 ? true : false
            });
            this.refreshAnimation(key);
        }
    };

    Wizard.prototype.finishButtonClick = function () {
        var _ref3 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            if (!(this.props.validate === false && this.props.finishButtonClick !== undefined || this.props.validate && (this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.isValidated !== undefined && this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.isValidated() || this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.isValidated === undefined) && this.props.finishButtonClick !== undefined)) {
                                _context2.next = 10;
                                break;
                            }

                            _context2.prev = 1;

                            if (!this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.onClickNext) {
                                _context2.next = 5;
                                break;
                            }

                            _context2.next = 5;
                            return this.props.stepRefs[this.props.steps[this.state.currentStep].stepName].current.onClickNext();

                        case 5:

                            this.props.finishButtonClick();
                            _context2.next = 10;
                            break;

                        case 8:
                            _context2.prev = 8;
                            _context2.t0 = _context2["catch"](1);

                        case 10:
                        case "end":
                            return _context2.stop();
                    }
                }
            }, _callee2, this, [[1, 8]]);
        }));

        function finishButtonClick() {
            return _ref3.apply(this, arguments);
        }

        return finishButtonClick;
    }();

    Wizard.prototype.refreshAnimation = function refreshAnimation(index) {
        var total = this.props.steps.length;
        var li_width = 100 / total;

        // var total_steps =
        //     this.props.steps !== undefined ? this.props.steps.length : 0;
        // var move_distance =
        //     this.refs.wizard !== undefined
        //         ? this.refs.navStepsLi.children[0].clientWidth / total_steps
        //         : 0;
        // var index_temp = index;
        var vertical_level = 0;

        var mobile_device = window.innerWidth < 600 && total > 3;

        if (mobile_device) {
            // move_distance = this.refs.navStepsLi.children[0].clientWidth / 2;
            index_temp = index % 2;
            li_width = 50;
        }

        this.setState({ width: li_width + "%" });

        // var step_width = move_distance;

        // move_distance = move_distance * index_temp;

        if (mobile_device) {
            vertical_level = parseInt(index / 2);
            vertical_level = vertical_level * 38;
        }

        // var movingTabStyle = {
        //     width: step_width,
        //     transform:
        //         "translate3d(" + move_distance + "px, " + vertical_level + "px, 0)",
        //     transition: "all 0.5s cubic-bezier(0.29, 1.42, 0.79, 1)"
        // };
        // this.setState({
        //     movingTabStyle: movingTabStyle
        // });
    };

    Wizard.prototype.render = function render() {
        var _this3 = this,
            _classnames,
            _classnames2,
            _classnames3;

        return _react2.default.createElement(
            "div",
            { className: "wizard-container", ref: "wizard" },
            _react2.default.createElement(
                _reactBootstrap.Card,
                { className: "card card-wizard active", variant: this.state.color },
                _react2.default.createElement(
                    _reactBootstrap.Tab.Container,
                    { id: "left-tabs-example", defaultActiveKey: "0", activeKey: this.state.currentStep, onSelect: function onSelect(k) {
                            return _this3.navigationStepChange(k);
                        } },
                    this.props.title !== undefined || this.props.description !== undefined ? _react2.default.createElement(
                        _reactBootstrap.Card.Header,
                        {
                            className: this.props.headerTextCenter !== undefined ? "text-center" : "",
                            "data-background-color": this.state.color
                        },
                        this.props.title !== undefined ? _react2.default.createElement(
                            _reactBootstrap.Card.Title,
                            { tag: "h3" },
                            this.props.title
                        ) : null,
                        this.props.description !== undefined ? _react2.default.createElement(
                            "h3",
                            { className: "description" },
                            this.props.description
                        ) : null,
                        _react2.default.createElement("br", null),
                        _react2.default.createElement(
                            "div",
                            { className: "wizard-navigation", ref: "navStepsLi" },
                            _react2.default.createElement(StepProgress, {
                                steps: this.props.steps,

                                currentStep: this.state.currentStep,
                                highestStep: this.state.highestStep,
                                color: this.props.color,
                                stepButtonClasses: this.props.stepButtonClasses
                            })
                        )
                    ) : null,
                    _react2.default.createElement(
                        _reactBootstrap.Card.Body,
                        null,
                        _react2.default.createElement(
                            _reactBootstrap.Tab.Content,
                            null,
                            this.props.steps.map(function (prop, key) {
                                var Component = _react2.default.forwardRef(prop.component);
                                return _react2.default.createElement(
                                    _reactBootstrap.Tab.Pane,
                                    {
                                        eventKey: key,
                                        key: key,
                                        className: (0, _classnames5.default)("fade", {
                                            show: _this3.state.currentStep === key
                                        })
                                    },
                                    typeof prop.component === "function" || _typeof(prop.component) === "object" ? _react2.default.createElement(Component, _extends({
                                        ref: stepRefs[prop.stepName]
                                    }, prop.stepProps)) : _react2.default.createElement(
                                        "div",
                                        { ref: prop.stepName },
                                        prop.component
                                    )
                                );
                            })
                        )
                    ),
                    _react2.default.createElement(
                        _reactBootstrap.Card.Footer,
                        null,
                        _react2.default.createElement(
                            "div",
                            { style: { float: "right" } },
                            this.state.nextButton ? _react2.default.createElement(
                                _reactBootstrap.Button,
                                {
                                    className: (0, _classnames5.default)("btn-next  rounded-0", (_classnames = {}, _classnames[this.props.nextButtonClasses] = this.props.nextButtonClasses !== undefined, _classnames)),
                                    onClick: function onClick() {
                                        return _this3.nextButtonClick();
                                    },
                                    variant: this.props.color
                                },
                                this.props.nextButtonText !== undefined ? this.props.nextButtonText : "Next"
                            ) : null,
                            this.state.finishButton ? _react2.default.createElement(
                                _reactBootstrap.Button,
                                {
                                    className: (0, _classnames5.default)("btn-finish rounded-0 d-inline-block", (_classnames2 = {}, _classnames2[this.props.finishButtonClasses] = this.props.finishButtonClasses !== undefined, _classnames2)),
                                    onClick: function onClick() {
                                        return _this3.finishButtonClick();
                                    },
                                    variant: this.props.color
                                },
                                this.props.finishButtonText !== undefined ? this.props.finishButtonText : "Finish"
                            ) : null
                        ),
                        _react2.default.createElement(
                            "div",
                            { style: { float: "left" } },
                            this.state.previousButton ? _react2.default.createElement(
                                _reactBootstrap.Button,
                                {
                                    className: (0, _classnames5.default)("btn-previous rounded-0", (_classnames3 = {}, _classnames3[this.props.previousButtonClasses] = this.props.previousButtonClasses !== undefined, _classnames3)),
                                    onClick: function onClick() {
                                        return _this3.previousButtonClick();
                                    },
                                    variant: "default"
                                },
                                this.props.previousButtonText !== undefined ? this.props.previousButtonText : "Previous"
                            ) : null
                        )
                    )
                )
            )
        );
    };

    return Wizard;
}(_react2.default.Component);

Wizard.defaultProps = {
    validate: false,
    previousButtonText: "Previous",
    finishButtonText: "Finish",
    nextButtonText: "Next",
    color: "primary",
    stepButtonClasses: "px-3 rounded"
};

ReactWizard.propTypes = process.env.NODE_ENV !== "production" ? {
    color: _propTypes2.default.oneOf(["primary", "secondary", "info", "warning", "danger", "success"]),
    previousButtonClasses: _propTypes2.default.string,
    finishButtonClasses: _propTypes2.default.string,
    nextButtonClasses: _propTypes2.default.string,
    stepButtonClasses: _propTypes2.default.string,
    headerTextCenter: _propTypes2.default.bool,
    navSteps: _propTypes2.default.bool,
    validate: _propTypes2.default.bool,
    finishButtonClick: _propTypes2.default.func,
    previousButtonText: _propTypes2.default.node,
    finishButtonText: _propTypes2.default.node,
    nextButtonText: _propTypes2.default.node,
    title: _propTypes2.default.node,
    description: _propTypes2.default.node,
    steps: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        stepName: _propTypes2.default.string.isRequired,
        stepIcon: _propTypes2.default.string,
        component: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.object]).isRequired,
        stepProps: _propTypes2.default.object
    })).isRequired
} : {};

exports.default = ReactWizard;
module.exports = exports["default"];